## kokkos 4.3.01

=== simd/CMakeLists.txt ===
IF (NOT Kokkos_INSTALL_TESTING)
  ADD_SUBDIRECTORY(src)
ENDIF()

KOKKOS_ADD_TEST_DIRECTORIES(unit_tests)

=== algorithms/src/CMakeLists.txt ===
#I have to leave these here for tribits
KOKKOS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
KOKKOS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

#-----------------------------------------------------------------------------

FILE(GLOB ALGO_HEADERS *.hpp)
FILE(GLOB ALGO_SOURCES *.cpp)
APPEND_GLOB(ALGO_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/std_algorithms/*.hpp)
APPEND_GLOB(ALGO_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/std_algorithms/impl/*.hpp)

INSTALL (
  DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/"
  DESTINATION ${KOKKOS_HEADER_DIR}
  FILES_MATCHING PATTERN "*.hpp"
)

#-----------------------------------------------------------------------------

# We have to pass the sources in here for Tribits
# These will get ignored for standalone CMake and a true interface library made
KOKKOS_ADD_INTERFACE_LIBRARY(
  kokkosalgorithms
  NOINSTALLHEADERS ${ALGO_HEADERS}
  SOURCES ${ALGO_SOURCES}
)
KOKKOS_LIB_INCLUDE_DIRECTORIES(kokkosalgorithms
  ${KOKKOS_TOP_BUILD_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)

KOKKOS_LINK_TPL(kokkoscontainers PUBLIC ROCTHRUST)
KOKKOS_LINK_TPL(kokkoscore PUBLIC ONEDPL)

=== algorithms/unit_tests/CMakeLists.txt ===

#Leave these here for now - I don't need transitive deps anyway
KOKKOS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
KOKKOS_INCLUDE_DIRECTORIES(REQUIRED_DURING_INSTALLATION_TESTING ${CMAKE_CURRENT_SOURCE_DIR})
KOKKOS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../src )
KOKKOS_INCLUDE_DIRECTORIES(${KOKKOS_SOURCE_DIR}/core/unit_test/category_files)


SET(ALGORITHM UnitTestMain.cpp)

foreach(Tag Threads;Serial;OpenMP;Cuda;HPX;HIP;SYCL;OpenMPTarget)
  string(TOUPPER ${Tag} DEVICE)
  string(TOLOWER ${Tag} dir)

  if(Kokkos_ENABLE_${DEVICE})
    set(dir ${CMAKE_CURRENT_BINARY_DIR}/${dir})
    file(MAKE_DIRECTORY ${dir})

    # ------------------------------------------
    # Sort
    # ------------------------------------------
    # Each of these inputs is an .hpp file.
    # Generate a .cpp file for each one that runs it on the current backend (Tag),
    # and add this .cpp file to the sources for UnitTest_RandomAndSort.
    set(ALGO_SORT_SOURCES)
    foreach(SOURCE_Input
	TestSort
	TestSortByKey
	TestSortCustomComp
	TestBinSortA
	TestBinSortB
	TestNestedSort
      )
      set(file ${dir}/${SOURCE_Input}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp
        "#include <Test${Tag}_Category.hpp>\n"
        "#include <${SOURCE_Input}.hpp>\n"
        )
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ALGO_SORT_SOURCES ${file})
    endforeach()

    # ------------------------------------------
    # Random
    # ------------------------------------------
    # do as above
    set(ALGO_RANDOM_SOURCES)
    foreach(SOURCE_Input
	TestRandom
      )
      set(file ${dir}/${SOURCE_Input}.cpp)
      file(WRITE ${dir}/dummy.cpp
        "#include <Test${Tag}_Category.hpp>\n"
        "#include <${SOURCE_Input}.hpp>\n"
        )
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ALGO_RANDOM_SOURCES ${file})
    endforeach()
  endif()
endforeach()

# ------------------------------------------
# std set A
# ------------------------------------------
set(STDALGO_SOURCES_A)
foreach(Name
	StdReducers
	StdAlgorithmsConstraints
	RandomAccessIterator
  )
  list(APPEND STDALGO_SOURCES_A Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std set B
# ------------------------------------------
set(STDALGO_SOURCES_B)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsMinMaxElementOps
  )
  list(APPEND STDALGO_SOURCES_B Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std set C
# ------------------------------------------
set(STDALGO_SOURCES_C)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsLexicographicalCompare
	StdAlgorithmsForEach
	StdAlgorithmsFind
	StdAlgorithmsFindFirstOf
	StdAlgorithmsFindEnd
	StdAlgorithmsCount
	StdAlgorithmsEqual
	StdAlgorithmsAllAnyNoneOf
	StdAlgorithmsAdjacentFind
	StdAlgorithmsSearch
	StdAlgorithmsSearch_n
	StdAlgorithmsMismatch
	StdAlgorithmsMoveBackward
  )
  list(APPEND STDALGO_SOURCES_C Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std set D
# ------------------------------------------
set(STDALGO_SOURCES_D)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsModOps
	StdAlgorithmsModSeqOps
	StdAlgorithmsReplace
	StdAlgorithmsReplaceIf
	StdAlgorithmsReplaceCopy
	StdAlgorithmsReplaceCopyIf
	StdAlgorithmsCopyIf
	StdAlgorithmsUnique
	StdAlgorithmsUniqueCopy
	StdAlgorithmsRemove
	StdAlgorithmsRemoveIf
	StdAlgorithmsRemoveCopy
	StdAlgorithmsRemoveCopyIf
	StdAlgorithmsRotate
	StdAlgorithmsRotateCopy
	StdAlgorithmsReverse
	StdAlgorithmsShiftLeft
	StdAlgorithmsShiftRight
  )
  list(APPEND STDALGO_SOURCES_D Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std set E
# ------------------------------------------
set(STDALGO_SOURCES_E)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsIsSorted
	StdAlgorithmsIsSortedUntil
	StdAlgorithmsPartitioningOps
	StdAlgorithmsPartitionCopy
	StdAlgorithmsNumerics
	StdAlgorithmsAdjacentDifference
	StdAlgorithmsExclusiveScan
	StdAlgorithmsInclusiveScan
	StdAlgorithmsTransformUnaryOp
	StdAlgorithmsTransformExclusiveScan
	StdAlgorithmsTransformInclusiveScan
  )
  list(APPEND STDALGO_SOURCES_E Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team Q
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_Q)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamInclusiveScan
	StdAlgorithmsTeamTransformInclusiveScan
  )
  list(APPEND STDALGO_TEAM_SOURCES_Q Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team P
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_P)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamExclusiveScan
	StdAlgorithmsTeamTransformExclusiveScan
  )
  list(APPEND STDALGO_TEAM_SOURCES_P Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team M
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_M)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamTransformUnaryOp
	StdAlgorithmsTeamTransformBinaryOp
	StdAlgorithmsTeamGenerate
	StdAlgorithmsTeamGenerate_n
	StdAlgorithmsTeamSwapRanges
  )
  list(APPEND STDALGO_TEAM_SOURCES_M Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team L
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_L)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamIsSorted
	StdAlgorithmsTeamIsSortedUntil
	StdAlgorithmsTeamIsPartitioned
	StdAlgorithmsTeamPartitionCopy
	StdAlgorithmsTeamPartitionPoint
  )
  list(APPEND STDALGO_TEAM_SOURCES_L Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team I
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_I)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamUnique
	StdAlgorithmsTeamAdjacentDifference
	StdAlgorithmsTeamReduce
	StdAlgorithmsTeamTransformReduce
  )
  list(APPEND STDALGO_TEAM_SOURCES_I Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team H
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_H)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamCopy
	StdAlgorithmsTeamCopy_n
	StdAlgorithmsTeamCopyBackward
	StdAlgorithmsTeamCopyIf
	StdAlgorithmsTeamUniqueCopy
	StdAlgorithmsTeamRemove
	StdAlgorithmsTeamRemoveIf
	StdAlgorithmsTeamRemoveCopy
	StdAlgorithmsTeamRemoveCopyIf
  )
  list(APPEND STDALGO_TEAM_SOURCES_H Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team G
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_G)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamMove
	StdAlgorithmsTeamMoveBackward
	StdAlgorithmsTeamShiftLeft
	StdAlgorithmsTeamShiftRight
  )
  list(APPEND STDALGO_TEAM_SOURCES_G Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team F
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_F)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamReverse
	StdAlgorithmsTeamReverseCopy
	StdAlgorithmsTeamRotate
	StdAlgorithmsTeamRotateCopy
  )
  list(APPEND STDALGO_TEAM_SOURCES_F Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team E
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_E)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamFill
	StdAlgorithmsTeamFill_n
	StdAlgorithmsTeamReplace
	StdAlgorithmsTeamReplaceIf
	StdAlgorithmsTeamReplaceCopy
	StdAlgorithmsTeamReplaceCopyIf
  )
  list(APPEND STDALGO_TEAM_SOURCES_E Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team D
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_D)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamMinElement
	StdAlgorithmsTeamMaxElement
	StdAlgorithmsTeamMinMaxElement
  )
  list(APPEND STDALGO_TEAM_SOURCES_D Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team C
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_C)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamFind
	StdAlgorithmsTeamFindIf
	StdAlgorithmsTeamFindIfNot
	StdAlgorithmsTeamAllOf
	StdAlgorithmsTeamAnyOf
	StdAlgorithmsTeamNoneOf
	StdAlgorithmsTeamSearchN
  )
  list(APPEND STDALGO_TEAM_SOURCES_C Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team B
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_B)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamEqual
	StdAlgorithmsTeamSearch
	StdAlgorithmsTeamFindEnd
	StdAlgorithmsTeamFindFirstOf
  )
  list(APPEND STDALGO_TEAM_SOURCES_B Test${Name}.cpp)
endforeach()

# ------------------------------------------
# std team A
# ------------------------------------------
set(STDALGO_TEAM_SOURCES_A)
foreach(Name
	StdAlgorithmsCommon
	StdAlgorithmsTeamAdjacentFind
	StdAlgorithmsTeamCount
	StdAlgorithmsTeamCountIf
	StdAlgorithmsTeamForEach
	StdAlgorithmsTeamForEachN
	StdAlgorithmsTeamLexicographicalCompare
	StdAlgorithmsTeamMismatch
  )
  list(APPEND STDALGO_TEAM_SOURCES_A Test${Name}.cpp)
endforeach()

# FIXME_OPENMPTARGET - remove sort test as it leads to ICE with clang/16 and above at compile time.
if(KOKKOS_ENABLE_OPENMPTARGET AND KOKKOS_CXX_COMPILER_ID STREQUAL "Clang" AND KOKKOS_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 16.0.0)
    list(REMOVE_ITEM ALGO_SORT_SOURCES
    TestSort.cpp
  )
endif()

# FIXME_OPENMPTARGET remove tests for OpenMPTarget because in these cases
# the impl needs to use either Kokkos or tailored reducers
# which results in runtime memory errors.
if(KOKKOS_ENABLE_OPENMPTARGET)
  list(REMOVE_ITEM STDALGO_TEAM_SOURCES_L
    TestStdAlgorithmsTeamIsPartitioned.cpp
    TestStdAlgorithmsTeamPartitionPoint.cpp
    TestStdAlgorithmsTeamPartitionCopy.cpp
  )
endif()

# FIXME_OPENMPTARGET need to remove tests for OpenMPTarget because
# in these cases the impl needs to use either Kokkos or
# tailored reducers which results in runtime memory errors.
if(KOKKOS_ENABLE_OPENMPTARGET)
  list(REMOVE_ITEM STDALGO_TEAM_SOURCES_C
    TestStdAlgorithmsTeamFind.cpp
    TestStdAlgorithmsTeamFindIf.cpp
    TestStdAlgorithmsTeamFindIfNot.cpp
    TestStdAlgorithmsTeamAllOf.cpp
    TestStdAlgorithmsTeamAnyOf.cpp
    TestStdAlgorithmsTeamNoneOf.cpp
    TestStdAlgorithmsTeamSearchN.cpp
  )
endif()

# FIXME_OPENMPTARGET This test causes internal compiler errors as of 09/01/22
# when compiling for Intel's Xe-HP GPUs.
# FRIZZI: 04/26/2023: not sure if the compilation error is still applicable
# but we conservatively leave this guard on
if(NOT (KOKKOS_ENABLE_OPENMPTARGET AND KOKKOS_CXX_COMPILER_ID STREQUAL IntelLLVM))
  KOKKOS_ADD_EXECUTABLE_AND_TEST(
    UnitTest_Sort
    SOURCES
    UnitTestMain.cpp
    TestStdAlgorithmsCommon.cpp
    ${ALGO_SORT_SOURCES}
  )

  KOKKOS_ADD_EXECUTABLE_AND_TEST(
    UnitTest_Random
    SOURCES
    UnitTestMain.cpp
    ${ALGO_RANDOM_SOURCES}
  )
endif()

# FIXME_OPENMPTARGET: These tests cause internal compiler errors as of 09/01/22
# when compiling for Intel's Xe-HP GPUs.
if(KOKKOS_ENABLE_OPENMPTARGET AND KOKKOS_CXX_COMPILER_ID STREQUAL IntelLLVM)
  list(REMOVE_ITEM STDALGO_SOURCES_D
    TestStdAlgorithmsCopyIf.cpp
    TestStdAlgorithmsRemoveCopy.cpp
    TestStdAlgorithmsUnique.cpp
    TestStdAlgorithmsUniqueCopy.cpp
  )
  list(REMOVE_ITEM STDALGO_SOURCES_E
    TestStdAlgorithmsExclusiveScan.cpp
    TestStdAlgorithmsInclusiveScan.cpp
  )
endif()

# FIXME_OPENMPTARGET remove tests for OpenMPTarget
# causing failures for various reasons
if(KOKKOS_ENABLE_OPENMPTARGET)
  # the following use either Kokkos or tailored reducers
  # which results in runtime memory errors.
  list(REMOVE_ITEM STDALGO_TEAM_SOURCES_B
    TestStdAlgorithmsTeamFindEnd.cpp
    TestStdAlgorithmsTeamFindFirstOf.cpp
    TestStdAlgorithmsTeamSearch.cpp
  )

  list(REMOVE_ITEM STDALGO_TEAM_SOURCES_A
    TestStdAlgorithmsTeamAdjacentFind.cpp

=== benchmarks/atomic/CMakeLists.txt ===
KOKKOS_ADD_EXECUTABLE(
  atomic
  SOURCES main.cpp
)

=== containers/unit_tests/CMakeLists.txt ===

KOKKOS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
KOKKOS_INCLUDE_DIRECTORIES(REQUIRED_DURING_INSTALLATION_TESTING ${CMAKE_CURRENT_SOURCE_DIR})
KOKKOS_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../src )
KOKKOS_INCLUDE_DIRECTORIES(${KOKKOS_SOURCE_DIR}/core/unit_test/category_files)

foreach(Tag Threads;Serial;OpenMP;HPX;Cuda;HIP;SYCL)
  string(TOUPPER ${Tag} DEVICE)
  string(TOLOWER ${Tag} dir)
  # Add test for that backend if it is enabled
  if(KOKKOS_ENABLE_${DEVICE})
    set(UnitTestSources UnitTestMain.cpp)
    set(dir ${CMAKE_CURRENT_BINARY_DIR}/${dir})
    file(MAKE_DIRECTORY ${dir})
    foreach(Name
        Bitset
        DualView
        DynamicView
        DynViewAPI_generic
        DynViewAPI_rank12345
        DynViewAPI_rank67
        ErrorReporter
        OffsetView
        ScatterView
        StaticCrsGraph
        WithoutInitializing
        UnorderedMap
        Vector
        ViewCtorPropEmbeddedDim
        )
      if(NOT Kokkos_ENABLE_DEPRECATED_CODE_4 AND Name STREQUAL "Vector")
        continue() # skip Kokkos::vector test if deprecated code 4 is not enabled
      endif()
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      file(WRITE ${dir}/dummy.cpp
          "#include <Test${Tag}_Category.hpp>\n"
          "#include <Test${Name}.hpp>\n"
      )
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND UnitTestSources ${file})
    endforeach()
    #fatal error C1128: number of sections exceeded object file format limit: compile with /bigobj
    if(KOKKOS_ENABLE_CUDA AND WIN32)
     LIST(REMOVE_ITEM UnitTestSources ${dir}/TestCuda_DynViewAPI_generic.cpp)
    endif()

    # FIXME_NVHPC: NVC++-S-0000-Internal compiler error. extractor: bad opc       0
    if(KOKKOS_ENABLE_CUDA AND KOKKOS_CXX_COMPILER_ID STREQUAL NVHPC)
     LIST(REMOVE_ITEM UnitTestSources ${dir}/TestCuda_WithoutInitializing.cpp)
    endif()

    KOKKOS_ADD_EXECUTABLE_AND_TEST(ContainersUnitTest_${Tag} SOURCES ${UnitTestSources})
  endif()
endforeach()

SET(COMPILE_ONLY_SOURCES
  TestCreateMirror.cpp
  TestDualViewParameterPack.cpp
  TestIsViewTrait.cpp
)
KOKKOS_ADD_EXECUTABLE(
  ContainersTestCompileOnly
  SOURCES
  TestCompileMain.cpp
  ${COMPILE_ONLY_SOURCES}
)

=== core/perf_test/CMakeLists.txt ===
# FIXME_OPENMPTARGET - the NVIDIA HPC compiler nvc++ in the OpenMPTarget backend does not pass the perf_tests.
# FIXME_OPENACC - temporarily disabled due to unimplemented features
IF ((KOKKOS_ENABLE_OPENMPTARGET OR KOKKOS_ENABLE_OPENACC) AND KOKKOS_CXX_COMPILER_ID STREQUAL NVHPC)
  RETURN()
ENDIF()
IF (KOKKOS_ENABLE_OPENACC AND KOKKOS_CXX_COMPILER_ID STREQUAL Clang)
  RETURN()
ENDIF()

# all PerformanceTest_* executables are part of regular tests
# TODO: finish converting these into benchmarks (in progress)
IF(KOKKOS_ENABLE_TESTS)
  IF(KOKKOS_ENABLE_CUDA OR KOKKOS_ENABLE_HIP OR KOKKOS_ENABLE_SYCL)
    KOKKOS_ADD_EXECUTABLE (
      PerformanceTest_SharedSpace
      SOURCES test_sharedSpace.cpp
    )
  ENDIF()

  KOKKOS_INCLUDE_DIRECTORIES(REQUIRED_DURING_INSTALLATION_TESTING ${CMAKE_CURRENT_SOURCE_DIR})

  IF(NOT Kokkos_ENABLE_OPENMPTARGET)
  # FIXME OPENMPTARGET needs tasking
    KOKKOS_ADD_EXECUTABLE_AND_TEST(
      PerformanceTest_TaskDag
      SOURCES test_taskdag.cpp
      CATEGORIES PERFORMANCE
    )
  ENDIF()
ENDIF()

IF(NOT Kokkos_ENABLE_BENCHMARKS)
  RETURN()
ENDIF()

IF (KOKKOS_HAS_TRILINOS)
  message(FATAL_ERROR "Benchmarks are not supported when building as part of Trilinos")
ENDIF()

# Find or download google/benchmark library
find_package(benchmark QUIET 1.5.6)
IF(benchmark_FOUND)
  MESSAGE(STATUS "Using google benchmark found in ${benchmark_DIR}")
ELSE()
  message(STATUS "No installed google benchmark found, fetching from GitHub")
  include(FetchContent)
  SET(BENCHMARK_ENABLE_TESTING OFF)

  list(APPEND CMAKE_MESSAGE_INDENT "[benchmark] ")
  FetchContent_Declare(
    googlebenchmark
    DOWNLOAD_EXTRACT_TIMESTAMP FALSE
    URL https://github.com/google/benchmark/archive/refs/tags/v1.7.1.tar.gz
    URL_HASH MD5=0459a6c530df9851bee6504c3e37c2e7
  )
  FetchContent_MakeAvailable(googlebenchmark)
  list(POP_BACK CMAKE_MESSAGE_INDENT)

  # Suppress clang-tidy diagnostics on code that we do not have control over
  IF(CMAKE_CXX_CLANG_TIDY)
    SET_TARGET_PROPERTIES(benchmark PROPERTIES CXX_CLANG_TIDY "")
  ENDIF()

  target_compile_options(benchmark PRIVATE -w)
  target_compile_options(benchmark_main PRIVATE -w)
ENDIF()


FUNCTION(KOKKOS_ADD_BENCHMARK NAME)
  CMAKE_PARSE_ARGUMENTS(
    BENCHMARK
    ""
    ""
    "SOURCES"
    ${ARGN}
  )
  IF(DEFINED BENCHMARK_UNPARSED_ARGUMENTS)
    MESSAGE(
      WARNING
      "Unexpected arguments when adding a benchmark: "
      ${BENCHMARK_UNPARSED_ARGUMENTS}
    )
  ENDIF()

  SET(BENCHMARK_NAME ${PACKAGE_NAME}_${NAME})
  LIST(APPEND BENCHMARK_SOURCES
    BenchmarkMain.cpp
    Benchmark_Context.cpp
  )

  ADD_EXECUTABLE(
    ${BENCHMARK_NAME}
    ${BENCHMARK_SOURCES}
  )
  TARGET_LINK_LIBRARIES(
    ${BENCHMARK_NAME}
    PRIVATE benchmark::benchmark Kokkos::kokkos impl_git_version
  )
  TARGET_INCLUDE_DIRECTORIES(
    ${BENCHMARK_NAME}
    SYSTEM PRIVATE ${benchmark_SOURCE_DIR}/include
  )

  FOREACH(SOURCE_FILE ${BENCHMARK_SOURCES})
    SET_SOURCE_FILES_PROPERTIES(
      ${SOURCE_FILE}
      PROPERTIES LANGUAGE ${KOKKOS_COMPILE_LANGUAGE}
    )
  ENDFOREACH()

  STRING(TIMESTAMP BENCHMARK_TIME "%Y-%m-%d_T%H-%M-%S" UTC)
  SET(
    BENCHMARK_ARGS
    --benchmark_counters_tabular=true
    --benchmark_out=${BENCHMARK_NAME}_${BENCHMARK_TIME}.json
  )

  ADD_TEST(
    NAME ${BENCHMARK_NAME}
    COMMAND ${BENCHMARK_NAME} ${BENCHMARK_ARGS}
  )
ENDFUNCTION()

SET(
  BENCHMARK_SOURCES
  PerfTestGramSchmidt.cpp
  PerfTest_CustomReduction.cpp
  PerfTest_ExecSpacePartitioning.cpp
  PerfTestHexGrad.cpp
  PerfTest_MallocFree.cpp
  PerfTest_ViewAllocate.cpp
  PerfTest_ViewCopy_a123.cpp
  PerfTest_ViewCopy_b123.cpp
  PerfTest_ViewCopy_c123.cpp
  PerfTest_ViewCopy_d123.cpp
  PerfTest_ViewCopy_a45.cpp
  PerfTest_ViewCopy_b45.cpp
  PerfTest_ViewCopy_c45.cpp
  PerfTest_ViewCopy_d45.cpp
  PerfTest_ViewCopy_a6.cpp
  PerfTest_ViewCopy_b6.cpp
  PerfTest_ViewCopy_c6.cpp
  PerfTest_ViewCopy_d6.cpp
  PerfTest_ViewCopy_a7.cpp
  PerfTest_ViewCopy_b7.cpp
  PerfTest_ViewCopy_c7.cpp
  PerfTest_ViewCopy_d7.cpp
  PerfTest_ViewCopy_a8.cpp
  PerfTest_ViewCopy_b8.cpp
  PerfTest_ViewCopy_c8.cpp
  PerfTest_ViewCopy_d8.cpp
  PerfTest_ViewCopy_Raw.cpp
  PerfTest_ViewFill_123.cpp
  PerfTest_ViewFill_45.cpp
  PerfTest_ViewFill_6.cpp
  PerfTest_ViewFill_7.cpp
  PerfTest_ViewFill_8.cpp
  PerfTest_ViewFill_Raw.cpp
  PerfTest_ViewResize_123.cpp
  PerfTest_ViewResize_45.cpp
  PerfTest_ViewResize_6.cpp
  PerfTest_ViewResize_7.cpp
  PerfTest_ViewResize_8.cpp
  PerfTest_ViewResize_Raw.cpp
)

IF(Kokkos_ENABLE_OPENMPTARGET)
# FIXME OPENMPTARGET requires TeamPolicy Reductions and Custom Reduction
  LIST(REMOVE_ITEM BENCHMARK_SOURCES
    PerfTestGramSchmidt.cpp
    PerfTest_CustomReduction.cpp
    PerfTest_ExecSpacePartitioning.cpp
  )
ENDIF()

KOKKOS_ADD_BENCHMARK(
  PerformanceTest_Benchmark
  SOURCES ${BENCHMARK_SOURCES}
)

IF(NOT KOKKOS_ENABLE_CUDA OR KOKKOS_ENABLE_CUDA_LAMBDA)
  KOKKOS_ADD_BENCHMARK(
    Benchmark_Atomic_MinMax
    SOURCES test_atomic_minmax_simple.cpp
  )
ENDIF()

# FIXME_NVHPC
IF(NOT KOKKOS_CXX_COMPILER_ID STREQUAL NVHPC)
  KOKKOS_ADD_BENCHMARK(
    PerformanceTest_Mempool
    SOURCES test_mempool.cpp
  )
ENDIF()

KOKKOS_ADD_BENCHMARK(
  PerformanceTest_Atomic
  SOURCES test_atomic.cpp
)

=== core/src/CMakeLists.txt ===
KOKKOS_INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${KOKKOS_TOP_BUILD_DIR}
)
IF (NOT desul_FOUND)
  IF(KOKKOS_ENABLE_CUDA)
    SET(DESUL_ATOMICS_ENABLE_CUDA ON)
  ENDIF()
  IF(KOKKOS_ENABLE_CUDA_RELOCATABLE_DEVICE_CODE)
    SET(DESUL_ATOMICS_ENABLE_CUDA_SEPARABLE_COMPILATION ON)
  ENDIF()
  IF(KOKKOS_ENABLE_HIP)
    SET(DESUL_ATOMICS_ENABLE_HIP ON)
  ENDIF()
  IF(KOKKOS_ENABLE_HIP_RELOCATABLE_DEVICE_CODE)
    SET(DESUL_ATOMICS_ENABLE_HIP_SEPARABLE_COMPILATION ON)
  ENDIF()
  IF(KOKKOS_ENABLE_SYCL)
    SET(DESUL_ATOMICS_ENABLE_SYCL ON)
    IF(KOKKOS_IMPL_SYCL_DEVICE_GLOBAL_SUPPORTED AND NOT KOKKOS_IMPL_HAVE_SYCL_EXT_ONEAPI_DEVICE_GLOBAL)
      SET(DESUL_ATOMICS_ENABLE_SYCL_SEPARABLE_COMPILATION ON)
    ENDIF()
  ENDIF()
  IF(KOKKOS_ENABLE_OPENMPTARGET)
    SET(DESUL_ATOMICS_ENABLE_OPENMP ON) # not a typo Kokkos OpenMPTarget -> Desul OpenMP
  ENDIF()
  IF(KOKKOS_ENABLE_OPENACC)
    SET(DESUL_ATOMICS_ENABLE_OPENACC ON)
  ENDIF()
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/Config.hpp.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/desul/atomics/Config.hpp
  )
  KOKKOS_INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include
  )
ENDIF()

INSTALL (DIRECTORY
  "${CMAKE_CURRENT_SOURCE_DIR}/"
  DESTINATION ${KOKKOS_HEADER_DIR}
  FILES_MATCHING
  PATTERN "*.hpp"
  PATTERN "*.h"
)

SET(KOKKOS_CORE_SRCS)
APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/impl/*.cpp)
SET(KOKKOS_CORE_HEADERS)
APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/*.hpp)
APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/impl/*.hpp)

IF (KOKKOS_ENABLE_CUDA)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Cuda/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/Cuda/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_OPENMP)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/OpenMP/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/OpenMP/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_OPENMPTARGET)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/OpenMPTarget/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/OpenMPTarget/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_OPENACC)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/OpenACC/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/OpenACC/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_THREADS)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Threads/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/Threads/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_HIP)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/HIP/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/HIP/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_HPX)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/HPX/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/HPX/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_SERIAL)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/Serial/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/Serial/*.hpp)
ENDIF()

IF (KOKKOS_ENABLE_SYCL)
  APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/SYCL/*.cpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/SYCL/*.hpp)
ENDIF()

IF (NOT desul_FOUND)
  IF (KOKKOS_ENABLE_CUDA)
    APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/src/Lock_Array_CUDA.cpp)
  ELSEIF (KOKKOS_ENABLE_HIP)
    APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/src/Lock_Array_HIP.cpp)
  ELSEIF (KOKKOS_ENABLE_SYCL)
    APPEND_GLOB(KOKKOS_CORE_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/src/Lock_Array_SYCL.cpp)
  ENDIF()
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include/desul/*.hpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include/desul/*/*.hpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include/desul/*/*/*.hpp)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include/*/*/*.inc*)
  APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_BINARY_DIR}/desul/*.hpp)

  INSTALL (DIRECTORY
    "${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include/desul"
    "${CMAKE_CURRENT_BINARY_DIR}/desul"
    DESTINATION ${KOKKOS_HEADER_DIR}
    FILES_MATCHING
    PATTERN "*.inc"
    PATTERN "*.inc_*"
    PATTERN "*.hpp"
  )

  MESSAGE(STATUS "Using internal desul_atomics copy")
ELSE()
  MESSAGE(STATUS "Using external desul_atomics install found at:")
  MESSAGE(STATUS "  " ${desul_DIR})
ENDIF()


KOKKOS_ADD_LIBRARY(
  kokkoscore
  SOURCES ${KOKKOS_CORE_SRCS}
  HEADERS ${KOKKOS_CORE_HEADERS}
  ADD_BUILD_OPTIONS # core should be given all the necessary compiler/linker flags
)

KOKKOS_LIB_INCLUDE_DIRECTORIES(kokkoscore
  ${KOKKOS_TOP_BUILD_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)
IF (NOT desul_FOUND)
  KOKKOS_LIB_INCLUDE_DIRECTORIES(kokkoscore
    ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/desul/include
  )
ENDIF()

IF (Kokkos_ENABLE_IMPL_MDSPAN)
  MESSAGE(STATUS "Experimental mdspan support is enabled")

  # Some compilers now include mdspan... we just flag on their version
  # for now until we can get some compiler detection support
  include(CheckIncludeFileCXX)
  check_include_file_cxx(experimental/mdspan KOKKOS_COMPILER_SUPPORTS_EXPERIMENTAL_MDSPAN)
  check_include_file_cxx(mdspan KOKKOS_COMPILER_SUPPORTS_MDSPAN)

  if (Kokkos_ENABLE_MDSPAN_EXTERNAL)
    MESSAGE(STATUS "Using external mdspan")
    target_link_libraries(kokkoscore PUBLIC std::mdspan)
  elseif(KOKKOS_COMPILER_SUPPORTS_MDSPAN AND NOT Kokkos_ENABLE_IMPL_SKIP_COMPILER_MDSPAN)
    message(STATUS "Using compiler-supplied mdspan")
  elseif(KOKKOS_COMPILER_SUPPORTS_EXPERIMENTAL_MDSPAN AND NOT Kokkos_ENABLE_IMPL_SKIP_COMPILER_MDSPAN)
    message(STATUS "Using compiler-supplied experimental/mdspan")
  else()
    KOKKOS_LIB_INCLUDE_DIRECTORIES(
      kokkoscore
      ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/mdspan/include
    )

    APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/mdspan/include/experimental/__p0009_bits/*.hpp)
    APPEND_GLOB(KOKKOS_CORE_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/mdspan/include/experimental/mdspan)

    INSTALL (DIRECTORY
      "${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/mdspan/include/"
      DESTINATION ${KOKKOS_HEADER_DIR}
      FILES_MATCHING
      PATTERN "mdspan"
      PATTERN "*.hpp"
    )
    MESSAGE(STATUS "Using internal mdspan directory ${CMAKE_CURRENT_SOURCE_DIR}/../../tpls/mdspan/include")
  endif()
ENDIF()

KOKKOS_LINK_TPL(kokkoscore PUBLIC HWLOC)
KOKKOS_LINK_TPL(kokkoscore PUBLIC CUDA)
KOKKOS_LINK_TPL(kokkoscore PUBLIC HPX)
KOKKOS_LINK_TPL(kokkoscore PUBLIC LIBDL)
# On *nix-like systems (Linux, macOS) we need pthread for C++ std::thread
IF (NOT WIN32)
  KOKKOS_LINK_TPL(kokkoscore PUBLIC THREADS)
ENDIF()
IF (NOT KOKKOS_ENABLE_COMPILE_AS_CMAKE_LANGUAGE)
  KOKKOS_LINK_TPL(kokkoscore PUBLIC ROCM)
ENDIF()

# FIXME: We need a proper solution to figure out whether to enable
#        libatomic
# Most compilers only require libatomic for 128-bit CAS
# I (CT) had removed 128bit CAS from desul to not need libatomic.
IF (KOKKOS_ENABLE_OPENMPTARGET)
  target_link_libraries(kokkoscore PUBLIC atomic)
ENDIF()

IF (desul_FOUND)
  target_link_libraries(kokkoscore PUBLIC desul_atomics)
ENDIF()

# FIXME_TRILINOS Trilinos doesn't allow for Kokkos to use find_dependency so we
# just append the flags in cmake/kokkos_tpls.cmake instead of linking with the
# OpenMP target.
IF(Kokkos_ENABLE_OPENMP AND NOT KOKKOS_HAS_TRILINOS)
  target_link_libraries(kokkoscore PUBLIC OpenMP::OpenMP_CXX)
ENDIF()

KOKKOS_LINK_TPL(kokkoscore PUBLIC LIBQUADMATH)

=== example/make_buildlink/Makefile ===
KOKKOS_DEVICES=OpenMP
KOKKOS_CUDA_OPTIONS=enable_lambda
KOKKOS_ARCH = "SNB,Kepler35"


MAKEFILE_PATH := $(subst Makefile,,$(abspath $(lastword $(MAKEFILE_LIST))))

ifndef KOKKOS_PATH
  KOKKOS_PATH = $(MAKEFILE_PATH)../..
endif

SRC = $(wildcard $(MAKEFILE_PATH)*.cpp)
HEADERS = $(wildcard $(MAKEFILE_PATH)*.hpp)

vpath %.cpp $(sort $(dir $(SRC)))

default: build
	echo "Start Build"

ifneq (,$(findstring Cuda,$(KOKKOS_DEVICES)))
CXX = ${KOKKOS_PATH}/bin/nvcc_wrapper
EXE = make_buildlink.cuda
else
CXX = g++
EXE = make_buildlink.host
endif

CXXFLAGS ?= -O3 -g
override CXXFLAGS += -I$(MAKEFILE_PATH)

DEPFLAGS = -M
LINK = ${CXX}
LINKFLAGS =

OBJ = $(notdir $(SRC:.cpp=.o))
LIB =

include $(KOKKOS_PATH)/Makefile.kokkos

build: $(EXE)

test: build
	./$(EXE)

$(EXE): $(SRC) $(KOKKOS_LINK_DEPENDS) $(KOKKOS_CPP_DEPENDS)
	$(CXX) $(KOKKOS_CPPFLAGS) $(KOKKOS_CXXFLAGS) $(CXXFLAGS) $(KOKKOS_CXXLDFLAGS) $(LINKFLAGS) $(EXTRA_PATH) $(SRC) $(KOKKOS_LIBS) $(LIB) -o $(EXE)

clean: kokkos-clean
	rm -f *.o *.cuda *.host

=== example/tutorial/04_simple_memoryspaces/CMakeLists.txt ===

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

# This is a tutorial, not a test, so we don't ask CTest to run it.
KOKKOS_ADD_EXECUTABLE(
  tutorial_04_simple_memoryspaces
  SOURCES simple_memoryspaces.cpp
)

=== example/tutorial/Advanced_Views/04_dualviews/CMakeLists.txt ===

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

# This is a tutorial, not a test, so we don't ask CTest to run it.
KOKKOS_ADD_EXECUTABLE(
  tutorial_advancedviews_04_dualviews
  SOURCES dual_view.cpp
)

=== debian/changelog ===
kokkos (4.3.01-1) unstable; urgency=medium

  * New upstream version.
  * Ack NMU.
  * d/patches: dropped as upstreamed.
  * Bump standards version to 4.7.0.
  * d/copyright: bump years.
  * d/control: adapted for new version.

 -- Alex Myczko <tar@debian.org>  Sun, 02 Jun 2024 21:29:57 +0000

=== debian/control ===
Source: kokkos
Section: science
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libhwloc-dev,
 libnuma-dev,
 libmemkind-dev,
 libopenmpi-dev,
 pkgconf
Standards-Version: 4.7.0
Homepage: https://github.com/kokkos/kokkos
Vcs-Browser: https://salsa.debian.org/debian/kokkos
Vcs-Git: https://salsa.debian.org/debian/kokkos.git
Rules-Requires-Root: no

Package: kokkos
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ Performance Portability Programming
 This implements a programming model in C++ for writing performance
 portable applications targeting all major HPC platforms. For that purpose it
 provides abstractions for both parallel execution of code and data management.
 Kokkos is designed to target complex node architectures with N-level memory
 hierarchies and multiple types of execution resources. It currently can use
 CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
 backends in development.

Package: libkokkos4.3
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ Performance Portability Programming
 This implements a programming model in C++ for writing performance
 portable applications targeting all major HPC platforms. For that purpose it
 provides abstractions for both parallel execution of code and data management.
 Kokkos is designed to target complex node architectures with N-level memory
 hierarchies and multiple types of execution resources. It currently can use
 CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
 backends in development.

Package: libkokkos-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 ${misc:Depends},
 libkokkos4.3 (= ${binary:Version}),
Description: C++ Performance Portability Programming
 This implements a programming model in C++ for writing performance
 portable applications targeting all major HPC platforms. For that purpose it
 provides abstractions for both parallel execution of code and data management.
 Kokkos is designed to target complex node architectures with N-level memory
 hierarchies and multiple types of execution resources. It currently can use
 CUDA, HPX, OpenMP and Pthreads as backend programming models with several other
 backends in development.
 .
 This is a development package of kokkos.

=== debian/watch ===
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/kokkos/kokkos/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
